////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI 8 Photo Isolator Input / 8 Relay Output
//                 Card VC++ 6.0 Sample (DII)
//
// # Used Library: Dynamic Industrial Interface (DII)
//
// # Designer:   Jason Hong         2004/06/18
//
////////////////////////////////////////////////////////////////////

// Dii_8P8RDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Dii_8P8R.h"
#include "Dii_8P8RDlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




/////////////////////////////////////////////////////////////////////////////
// CDii_8P8RDlg dialog

CDii_8P8RDlg::CDii_8P8RDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDii_8P8RDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDii_8P8RDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDii_8P8RDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDii_8P8RDlg)
	DDX_Control(pDX ,IDC_BUTTON10,msg1 );
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDii_8P8RDlg, CDialog)
	//{{AFX_MSG_MAP(CDii_8P8RDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_BUTTON1,IDC_BUTTON8,OnBitToggled)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDii_8P8RDlg message handlers

BOOL CDii_8P8RDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	BOOL init;
	BOOL temp;
	BYTE byState;
	char DevName[200];
	CString str;

    init = DiiSelectDevice(NULL, DevName, 210);

	if (init == false)
		msg1.SetWindowText("Can't find the port!");
	
	hDevice = DiiOpenNamedDevice(DevName, true);	

	if (hDevice != INVALID_HANDLE_VALUE){
		msg1.SetWindowText( "Get card address success !!");
		temp = DiiSetDigitalByte(hDevice, 0, 0);
		temp = DiiGetDigitalByte(hDevice, 0, &byState);
	}
	else{
		msg1.SetWindowText( "Get card address fail !!");
	}
	
	
	
	m_nTimer = SetTimer (1, 1, 0);
	

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

//  If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDii_8P8RDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDii_8P8RDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CDii_8P8RDlg::OnBitToggled(UINT idButton)
{

    BOOL bState = IsDlgButtonChecked (idButton);
	DWORD dwBit = idButton - IDC_BUTTON1;
	UCHAR utemp=0,uctemp = 0;
	
	//dwBit means the offset 

	
	// reset all buttons
	for(DWORD q = 0; q < 8 ; q++)
	{
		if(q != dwBit)
			CheckDlgButton (IDC_BUTTON1+q,FALSE);
	}

	// calculate the output value
	if(bState)
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
	}
	else
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
	}

	// Now take into account any output bank configured:
	
	if (!DiiSetDigitalByte(hDevice, 0, uctemp))
	{
		//
		// If unsuccessfull, restore the state of the output button:
		//
		CheckDlgButton (idButton,FALSE);
	}

}


void CDii_8P8RDlg::OnTimer(UINT nIDEvent) 
{	
	BOOL temp;
	UCHAR ubit;
	UCHAR utemp=0;
	CString str;

	//
	// input the value that we just output
	//	and show the results
	temp = DiiGetDigitalByte(hDevice, 0, &utemp);
 		
	
	for(int i = 0; i < 8; i++)
	{
		ubit = utemp >> i;
		ubit = ubit & 0x01;
		
		if( ubit )
			CheckDlgButton(IDC_CHECK1+i, BST_CHECKED);		// 1
		else
			CheckDlgButton(IDC_CHECK1+i, BST_UNCHECKED);	// 0
	
	
	}
	CDialog::OnTimer(nIDEvent);

}

