// DrawDialog.cpp : implementation file
//

#include "stdafx.h"
#include "host.h"
#include "DrawDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DrawDialog dialog


DrawDialog::DrawDialog(CWnd* pParent /*=NULL*/)
	: CDialog(DrawDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(DrawDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	 pen_bl.CreatePen (PS_SOLID, 1, RGB (0, 0, 0));
	 pen_rd.CreatePen (PS_SOLID, 1, RGB (192, 0, 0));
	 pen_bu.CreatePen (PS_DOT, 1, RGB (0, 0, 192));
	 pen_gn.CreatePen (PS_DOT, 1, RGB (0, 192, 0));
	 pen_bg.CreatePen (PS_SOLID, 1, RGB (236, 233, 216));

	 count = 0;
	 MAX = 256;
	 WIDTH = 600;
	 HEIGHT = 200;
	 BK = 50;
	 Exist = false;
	 for(int j = 0;j < MAX; j++){
	 	aPoint1[j].x = BK + j*2;
	 }

	 //OnOK();
}


void DrawDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DrawDialog)
	DDX_Control(pDX, IDC_COMBO_Override, m_Override);
	//}}AFX_DATA_MAP
	int i = 0;
	for(i = 0 ; i<3 ; i++)
       DDX_Control(pDX, IDC_BDrawMin+i, Range[i]) ;
  DDX_Control(pDX, IDC_BDrawNow, NowValue) ;

}


BEGIN_MESSAGE_MAP(DrawDialog, CDialog)
	//{{AFX_MSG_MAP(DrawDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DrawDialog message handlers

void DrawDialog::DrawBg(){
	 CClientDC dc(this);
	 bool fColor;
	 dx = BK;
	 dy = BK;
	 dc.MoveTo (dx, dy);
	 dy += HEIGHT;
	 dc.LineTo (dx, dy);
	 dx += WIDTH;
	 dc.LineTo (dx, dy);

	 dc.SelectObject(pen_gn);

	 dx = BK;
	 dy = BK;

	 fColor = true;

	 for(m = 0; m < HEIGHT; m = m + (HEIGHT / 20)){
		  dx = BK;
		  dy = m + BK;
			if(fColor){
				dc.MoveTo (dx - 20 , dy);
				dc.SelectObject(pen_gn);
			}
			else{
				dc.MoveTo (dx , dy);
				dc.SelectObject(pen_bu);
			}
			fColor = !fColor;
		  dx += WIDTH;
		  dc.LineTo (dx, dy);
	 }

	 OnPaint();
}
void DrawDialog::DrawTest1(){
	 CClientDC dc(this);
	 dc.SelectObject(pen_bl);
	 dx = BK;
	 dy = BK;
	 dc.MoveTo (dx, dy);
	 dx += WIDTH;
	 dy += HEIGHT;
	 dc.LineTo (dx, dy);
}
void DrawDialog::DrawTest2(){
	 CClientDC dc(this);
	 dc.SelectObject(pen_rd);
	 dx = BK;
	 dy = BK;
	 dc.MoveTo (dx, dy);
	 dx += WIDTH;
	 dy += HEIGHT;
	 dc.LineTo (dx, dy);
}
void DrawDialog::DrawTest3(){
	 DrawBg();
	 if(i == 0){
		  DrawTest1();
		  i = 1;
	 }
	 else{
		  DrawTest2();
		  i = 0;
	 }
}
void DrawDialog::Draw(unsigned long value){
	 unsigned int m,n,t_max,t_mid,t_min;
	 char buff[20];
	 CClientDC dc(this);
	 DrawBg();

	 dc.SelectObject(pen_bg);
	 dc.PolyBezier (aPoint1, 256);
	 dc.SelectObject(pen_rd);
	 m = m_Override.GetCurSel();
	 if(m == -1){
			m_Override.SetCurSel(0);
			m = m_Override.GetCurSel();
	 }
	 n = m;
	 if(m != -1)
		  m = 0xFFFF >> (m -1);
	 else
		  m = 0xFFFF;
	 if(m == 0)
		  m = 0xFFFF;
	 n = 16 - n;
	 t_min = (value >> n)<<n;
	 t_max = ((value >> n)+1)<<n;
	 t_mid = ((t_max - t_min) >> 1) + t_min;
	 sprintf_s(buff,"0x%x",t_min);
	 Range[0].SetWindowText(buff);
	 sprintf_s(buff,"0x%x",t_mid);
	 Range[1].SetWindowText(buff);
	 sprintf_s(buff,"0x%x",t_max);
	 Range[2].SetWindowText(buff);
	 sprintf_s(buff,"0x%4x",value);
	 NowValue.SetWindowText(buff);
	 aPoint1[count].y = BK + HEIGHT - ((value - t_min) * HEIGHT / (t_max - t_min));
	 dc.PolyBezier (aPoint1, 256);
	 OnPaint();

	 count++;
	 if(count >= MAX){
		  count = 0;
	 }
}
void DrawDialog::OnOK() 
{
	 CClientDC dc(this);
	// TODO: Add extra validation here
	dc.PolyBezier (aPoint1, 256);

	//CDialog::OnOK();
	Exist = false;
}
