// hostDlg.cpp : implementation file
//

#include "stdafx.h"
#include "host.h"
#include "hostDlg.h"
// Custom Application Definitions

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

enum {TIMER_DIO_READ,TIMER_DIO_AUTO,TIMER_AD_READ,TIMER_DA_AUTO};

HANDLE hCom;
int fSuccess;
unsigned long num;
const int BUFFMAX = 128;
char cTx[BUFFMAX];
char cRx[BUFFMAX];
/////////////////////////////////////////////////////////////////////////////
// CHostDlg dialog

CHostDlg::CHostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHostDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHostDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHostDlg::DoDataExchange(CDataExchange* pDX)
{
	//CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostDlg)
	DDX_Control(pDX, IDC_SLI_T_DA1, m_Sli_T_DA1);
	DDX_Control(pDX, IDC_SLI_T_DA0, m_Sli_T_DA0);
	DDX_Control(pDX, IDC_COMBO_DIP, m_COMDIP);
	DDX_Control(pDX, IDC_SLI_DIO, m_Sli_DIO);
	DDX_Control(pDX, IDC_COMBO_bps, m_COMbps);
	DDX_Control(pDX, IDC_COMBO_PortNum, m_COMPortNum);
	//}}AFX_DATA_MAP
	int i = 0;
	for(i = 0 ; i<16 ; i++)
       DDX_Control(pDX, IDC_CHECK1+i, PushButton[i]) ;
	for(i = 0 ; i<16 ; i++)
       DDX_Control(pDX, IDC_CADC0+i, ADC_Check[i]) ;
	for(i = 0 ; i<4 ; i++)
       DDX_Control(pDX, IDC_RADIO1+i, InOutctrl[i]) ;
	for(i = 0 ; i<16 ; i++)
       DDX_Control(pDX, IDC_ADV_0+i, ADResult[i]) ;

	for(i = 0 ; i<2 ; i++)
       DDX_Control(pDX, IDC_SLI_DA0+i, SliDA[i]) ;
	for(i = 0 ; i<2 ; i++)
       DDX_Control(pDX, IDC_E_DA0+i, DA_Value[i]) ;
	for(i = 0 ; i<16 ; i++)
       DDX_Control(pDX, IDC_B_ADC_0+i, B_ADC[i]) ;
	
		 /*
	for(i = 0 ; i<19 ; i++)
       DDX_Control(pDX, IDC_R_DA0_Range0+i, RadioRange[i]) ;
		 */
}

BEGIN_MESSAGE_MAP(CHostDlg, CDialog)
	//{{AFX_MSG_MAP(CHostDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_CANCELMODE()
	ON_BN_CLICKED(ID_COM_Open, OnCOMOpen)
	ON_BN_CLICKED(IDC_B_DIOAutoTest, OnBDIOAutoTest)
	ON_BN_CLICKED(IDC_B_DAAutoTest, OnBDAAutoTest)
	ON_BN_CLICKED(IDC_B_SetDA0, OnBSetDA0)
	ON_BN_CLICKED(IDC_B_SetDA1, OnBSetDA1)
	ON_BN_CLICKED(IDC_R_DIO_Auto, OnRDIOAuto)
	ON_BN_CLICKED(IDC_R_DIO_Manual, OnRDIOManual)
	ON_BN_CLICKED(IDC_R_DA_Auto, OnRDAAuto)
	ON_BN_CLICKED(IDC_R_DA_Manual, OnRDAManual)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLI_DA0, OnReleasedcaptureSliDa0)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLI_DA1, OnReleasedcaptureSliDa1)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_CHECK1,IDC_CHECK16,ManualTest)
	ON_COMMAND_RANGE(IDC_CADC0,IDC_CADC15,ADCCheck)
	ON_COMMAND_RANGE(IDC_RADIO1,IDC_RADIO4,IOSwitch)
	ON_COMMAND_RANGE(IDC_R_DA0_Range0,IDC_R_DA0_Range6,SetDA0Range)
	ON_COMMAND_RANGE(IDC_R_DA1_Range0,IDC_R_DA1_Range6,SetDA1Range)
	ON_COMMAND_RANGE(IDC_R_AD_Range0,IDC_R_AD_Range4,SetADRange)
	ON_COMMAND_RANGE(IDC_B_ADC_0,IDC_B_ADC_F,ADDraw)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CHostDlg::OnCbnSelchangeCombo1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostDlg message handlers

BOOL CHostDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	Init(FALSE);
	SliDA[0].SetRange(0,0xFFFF,TRUE);
	SliDA[0].SetPageSize(0x100);
	SliDA[1].SetRange(0,0xFFFF,TRUE);
	SliDA[1].SetPageSize(0x100);

	// TODO: Add extra initialization here
	AutoNowOut = 0;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHostDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHostDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHostDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	// Confirm an error hasn't already occurred
	switch(nIDEvent)
	{
		case TIMER_DIO_READ:
		{
			TIMER_DIO_READ_f();
			break;
		}
		case TIMER_DIO_AUTO:
		{
			TIMER_DIO_AUTO_f();
			break;
		}
		case TIMER_AD_READ:
		{
			TIMER_AD_READ_f();
			break;
		}
		case TIMER_DA_AUTO:
		{
			TIMER_DA_AUTO_f();
			break;
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CHostDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default	
	CloseConnection();
	CDialog::OnClose();
}

void CHostDlg::OnDestroy() 
{
	CloseConnection();
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
}

void CHostDlg::OnCancelMode() 
{
	CloseConnection();
	CDialog::OnCancelMode();
	// TODO: Add your message handler code here
	
}

void CHostDlg::CloseConnection() {

	KillTimer(1);
}

//void CHostDlg::OnDetectBoard(void) {
//	AfxMessageBox("USB device not found. Check USB cable.",MB_OK|MB_ICONEXCLAMATION);
//}

#include <dbt.h>
#include ".\hostdlg.h"
LRESULT CHostDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) {
	// HID connect/disconnect messages will be sent to the WindowProc via
	// WM_DEVICECHANGE. Most sub-events will be ignored. The relevant sub-events will
	// be reflected in the GUI.
	if(message==WM_DEVICECHANGE) {
		FlashWindow(1);
		DEV_BROADCAST_DEVICEINTERFACE* pDevHdr = (DEV_BROADCAST_DEVICEINTERFACE*)lParam;
/*		if(pDevHdr) { if(pDevHdr->dbcc_devicetype==DBT_DEVTYP_DEVICEINTERFACE) {
		switch(wParam) {
		case DBT_CONFIGCHANGECANCELED: //  A request to change the current configuration (dock or undock) has been canceled.
			break;
		case DBT_CONFIGCHANGED: //  The current configuration has changed, due to a dock or undock.
			break;
		case DBT_CUSTOMEVENT: //  Windows 98/Me, Windows 2000 or later: A custom event has occurred.
			break;
		case DBT_DEVICEARRIVAL: { // A device has been inserted and is now available.
//			OnDetectBoard();
			break;
			}
		case DBT_DEVICEQUERYREMOVE: // Permission is requested to remove a device. Any application can deny this request and cancel the removal.
			break;
		case DBT_DEVICEQUERYREMOVEFAILED: // A request to remove a device has been canceled.
			break;
		case DBT_DEVICEREMOVECOMPLETE: { // A device has been removed.
			OnCancel();
			break;
			}
		case DBT_DEVICEREMOVEPENDING: // A device is about to be removed. Cannot be denied.
			break;
		case DBT_DEVICETYPESPECIFIC: // A device-specific event has occurred.
			break;
		case DBT_QUERYCHANGECONFIG: // Permission is requested to change the current configuration (dock or undock).
			break;
		case DBT_USERDEFINED:
			break;
		default:
			break;

		} } } else {
		}*/
	}

	return CDialog::WindowProc(message, wParam, lParam);
}
void CHostDlg::TIMER_DIO_AUTO_f(){};
void CHostDlg::TIMER_DA_AUTO_f(){};

void CHostDlg::TIMER_DIO_READ_f(){
	char * ptr;
	int i,j;
	if(InOutctrl[0].GetCheck() == 1){
		sprintf_s(cTx,"S%cR0",tmpc);
		fSuccess = WriteFile(hCom,cTx,4,&num,NULL);
		fSuccess = ReadFile(hCom,cRx,128,&num,NULL);
		ptr = strstr(cRx,"R00");
		if(ptr == NULL){
			;
		}
		else{
			if((ptr[3]>='0')&&(ptr[3]<='9')){
				i = ptr[3] - '0';
			}
			if((ptr[3]>='A')&&(ptr[3]<='F')){
				i = ptr[3] - 'A' + 10;
			}
			i = i * 16;
			if((ptr[4]>='0')&&(ptr[4]<='9')){
				i += ptr[4] - '0';
			}
			if((ptr[4]>='A')&&(ptr[4]<='F')){
				i += ptr[4] - 'A' + 10;
			}
			for(j = 0;j<8;j++){
				PushButton[j].SetCheck(((i & (0x01<<j)) ==0));
			}
		}
	}
	if(InOutctrl[2].GetCheck() == 1){
		sprintf_s(cTx,"S%cR1",tmpc);
		fSuccess = WriteFile(hCom,cTx,4,&num,NULL);
		fSuccess = ReadFile(hCom,cRx,128,&num,NULL);
		ptr = strstr(cRx,"R01");
		if(ptr == NULL){
			;
		}
		else{
			if((ptr[3]>='0')&&(ptr[3]<='9')){
				i = ptr[3] - '0';
			}
			if((ptr[3]>='A')&&(ptr[3]<='F')){
				i = ptr[3] - 'A' + 10;
			}
			i = i * 16;
			if((ptr[4]>='0')&&(ptr[4]<='9')){
				i += ptr[4] - '0';
			}
			if((ptr[4]>='A')&&(ptr[4]<='F')){
				i += ptr[4] - 'A' + 10;
			}
			for(j = 0;j<8;j++){
				PushButton[j + 8].SetCheck(((i & (0x01<<j)) ==0));
			}
		}
	}
}

void CHostDlg::TIMER_AD_READ_f() 
{
	 int i,got_ad_num;
	 unsigned long adr[16];
	 static unsigned long long DrawResult[10];
	 char *ptr,tmpstr2[20];
	 char adresulttmp[40];
	 static int j = 0;

	 sprintf_s(cTx,"S%cAR",tmpc);
	 fSuccess = WriteFile(hCom,cTx,4,&num,NULL);
	 got_ad_num = 0;
	 for(i = 0;i<16;i++){
		  adr[i] = 0xFFFFFFFF;
	 }
	 fSuccess = ReadFile(hCom,cRx,128,&num,NULL);
	 for(i = 0;i<16;i++){
		if(i < 10)
			 sprintf_s(tmpstr2,"P%c",i+'0');
		else
			 sprintf_s(tmpstr2,"P%c",i+'A'-10);
		ptr = strstr(cRx,tmpstr2);
		if((ptr != NULL) && (adr[i] == 0xFFFFFFFF) && (ADC_Check[i].GetCheck() == BST_CHECKED)){
			 adr[i] = 0;
			 if(ptr[2] > '9' )
				  adr[i] += (ptr[2] - 'A' + 0x0A) * 0x1000;
			 else
				  adr[i] += (ptr[2] - '0') * 0x1000;
			 if(ptr[3] > '9' )
				  adr[i] += (ptr[3] - 'A' + 0x0A) * 0x100;
			 else
				  adr[i] += (ptr[3] - '0') * 0x100;
			 if(ptr[4] > '9' )
				  adr[i] += (ptr[4] - 'A' + 0x0A) * 0x10;
			 else
				  adr[i] += (ptr[4] - '0') * 0x10;
			 if(ptr[5] > '9' )
				  adr[i] += (ptr[5] - 'A' + 0x0A) * 0x1;
			 else
				  adr[i] += (ptr[5] - '0') * 0x1;
			 sprintf_s(adresulttmp,"%x",adr[i]);
			 //sprintf_s(adresulttmp,"%1fuV",adr[i] * 152.6);
			 ADResult[i].SetWindowText(adresulttmp);
//			 adr[i] = strtol(ptr+3,NULL,10);
			 got_ad_num++;
		}
	 }
	 if(dlg.Exist){
		 if(j == 10){
			unsigned long long DrawResultAvg;
			long MAX,MIN;
			MAX = DrawResult[0];
			MIN = DrawResult[0];
			DrawResultAvg = 0;
			for(int ii = 0; ii<j;ii++){
				if(DrawResult[ii] > MAX){
					MAX = DrawResult[ii];
				}
				if(DrawResult[ii] < MIN){
					MIN = DrawResult[ii];
				}
				DrawResultAvg += DrawResult[ii];
			}
			DrawResultAvg -= MAX+MIN;
			DrawResultAvg = DrawResultAvg / (j - 2);
			dlg.Draw((unsigned long)(DrawResultAvg));
			j = 0;
		 }
		 else{
			 DrawResult[j] = (unsigned long long)adr[DrawChannel];
			 j++;
		 }
	 }
}
void CHostDlg::ADCCheck(unsigned int id_checked){
	 
	 id_checked -= IDC_CADC0;
	 if(ADC_Check[id_checked].GetCheck() == BST_UNCHECKED)
		  sprintf_s(cTx,"S%cAD%x",tmpc,id_checked);
	 else
		  sprintf_s(cTx,"S%cAE%x",tmpc,id_checked);
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);
}
void CHostDlg::ManualTest(unsigned int id_button_pushed)
{
	int write_data = 0;
	int i;
	id_button_pushed -= IDC_CHECK1;
	int j = (id_button_pushed&(~0x07)) + 7;
	for(int i = 0; i < 8;i++)
	{
		write_data += PushButton[j].GetCheck();
		write_data <<= 1;
		j -= 1;
	}
	write_data >>= 1;
	if(id_button_pushed > 0x07){
		  sprintf_s(cTx,"S%cW1%02x",tmpc,write_data);
	}
	else{
		  sprintf_s(cTx,"S%cW0%02x",tmpc,write_data);
	}

	j = (id_button_pushed&(~0x07)) + 7;
	for(i = 8; i < 16;i++)
	{
		write_data += PushButton[j].GetCheck();
		write_data <<= 1;
		j -= 1;
	}
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);

//	hid_write(hUSB, id_button_pushed/8, write_data);
//	Timer0();
}
void CHostDlg::IOSwitch(unsigned int idButton)
{
	int i;
	idButton -= IDC_RADIO1;
	if((idButton %2) == 0)
	{
		for(i = 0 ; i<8 ; i++)
		{
			PushButton[i+((idButton/2)*8)].SetCheck(false);
			PushButton[i+((idButton/2)*8)].EnableWindow(false);
		}
	}
	else
	{
		for(i = 0 ; i<8 ; i++)
		{
			PushButton[i+((idButton/2)*8)].SetCheck(false);
			PushButton[i+((idButton/2)*8)].EnableWindow(true);
		}
	}
}
void CHostDlg::Init(bool IsInit)
{
	int j;
	for(j = 0 ; j< 16 ;j++)
	{
       PushButton[j].EnableWindow(IsInit);
       PushButton[j].SetCheck(IsInit);	   
	}
	for(j = 0 ; j< 16 ;j++)
	{
       ADC_Check[j].EnableWindow(IsInit);
       ADC_Check[j].SetCheck(IsInit);	   
	}		 
	for(j = 0 ; j < 4; j++)
	{
		InOutctrl[j].EnableWindow(IsInit);
		if((j % 2) == 0)
		  InOutctrl[j].SetCheck(FALSE);
		else
		  InOutctrl[j].SetCheck(TRUE);
	}
	for(j = 0 ; j < 16; j++)
	{
		ADResult[j].EnableWindow(IsInit);
		ADResult[j].SetWindowText("0");
	}

	m_Sli_DIO.SetPos(m_Sli_DIO.GetRangeMax()/2);
	m_Sli_T_DA0.SetPos(m_Sli_T_DA0.GetRangeMax()/2);
	m_Sli_T_DA1.SetPos(m_Sli_T_DA1.GetRangeMax()/2);

	KillTimer(1);
	// TODO: Add extra initialization here
	AutoNowOut = 0;
}


void CHostDlg::OnCOMOpen() 
{
	char commPort[20] = "\\\\.\\COM" ;
	char buff[5];
	DCB dcb;


COMMTIMEOUTS comTimeOut;                   // instance an object of COMMTIMEOUTS.

comTimeOut.ReadIntervalTimeout = 3;// Specify time-out between charactor for receiving.
comTimeOut.ReadTotalTimeoutMultiplier = 3;// Specify value that is multiplied by the requested number of bytes to be read. 
comTimeOut.ReadTotalTimeoutConstant = 2;// Specify value is added to the product of the ReadTotalTimeoutMultiplier member
comTimeOut.WriteTotalTimeoutMultiplier = 3;// Specify value that is multiplied by the requested number of bytes to be sent. 
comTimeOut.WriteTotalTimeoutConstant = 2;// Specify value is added to the product of the WriteTotalTimeoutMultiplier member
// set the time-out parameter into device control.

	sprintf_s(buff,"%d",m_COMPortNum.GetCurSel());
	strncat(commPort,buff,2);
	hCom = CreateFile(		commPort,
						   GENERIC_READ | GENERIC_WRITE,
						   0,    // must be opened with exclusive-access
						   NULL, // no security attributes
						   OPEN_EXISTING, // must use OPEN_EXISTING
						   0,    // not overlapped I/O
						   NULL  // hTemplate must be NULL for comm devices
						   );
	dcb.DCBlength = sizeof (DCB); 
   fSuccess = GetCommState(hCom, &dcb);
	tmpc = m_COMDIP.GetCurSel();
	if(tmpc > 9)
		  tmpc = tmpc + 'A';
	else
		  tmpc = tmpc + '0';
   dcb.BaudRate = CBR_115200;     // set the baud rate
	switch(m_COMbps.GetCurSel()){
		 case(0):
			  dcb.BaudRate = CBR_1200;
			  break;
		 case(1):
			  dcb.BaudRate = CBR_2400;
			  break;
		 case(2):
			  dcb.BaudRate = CBR_4800;
			  break;
		 case(3):
			  dcb.BaudRate = CBR_9600;
			  break;
		 case(4):
			  dcb.BaudRate = CBR_19200;
			  break;
		 case(5):
			  dcb.BaudRate = CBR_38400;
			  break;
		 case(6):
			  dcb.BaudRate = CBR_57600;
			  break;
		 case(7):
			  dcb.BaudRate = CBR_115200;
			  break;
	}
	dcb.fBinary = TRUE;               // Binary mode; no EOF check 
	dcb.fParity = TRUE;               // Enable parity checking 
	dcb.fOutxCtsFlow = FALSE;         // No CTS output flow control 
	dcb.fOutxDsrFlow = FALSE;         // No DSR output flow control 
	dcb.fDtrControl = DTR_CONTROL_ENABLE; 
                                      // DTR flow control type 
	dcb.fDsrSensitivity = FALSE;      // DSR sensitivity 
	dcb.fTXContinueOnXoff = TRUE;     // XOFF continues Tx 
	dcb.fOutX = FALSE;                // No XON/XOFF out flow control 
	dcb.fInX = FALSE;                 // No XON/XOFF in flow control 
	dcb.fErrorChar = FALSE;           // Disable error replacement 
	dcb.fNull = FALSE;                // Disable null stripping 
	dcb.fRtsControl = RTS_CONTROL_ENABLE; 
                                      // RTS flow control 
	dcb.fAbortOnError = TRUE;        // Do not abort reads/writes on 
                                      // error
	dcb.ByteSize = 8;                 // Number of bits/byte, 4-8 
	dcb.Parity = NOPARITY;            // 0-4=no,odd,even,mark,space 
	dcb.StopBits = ONESTOPBIT;        // 0,1,2 = 1, 1.5, 2 
	 SetCommTimeouts(hCom,&comTimeOut);

   fSuccess = SetCommState(hCom, &dcb);

	 sprintf_s(cTx,"s0ars0ar",tmpc);
	 fSuccess = WriteFile(hCom,cTx,4,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,4,&num,NULL);

	if(fSuccess){
		 SetTimer(TIMER_AD_READ,0,0);
		 SetTimer(TIMER_DIO_READ,50,0);
		 Init(TRUE);
	}
}

void CHostDlg::OnBDIOAutoTest() 
{
}

void CHostDlg::OnBDAAutoTest() 
{
	// TODO: Add your control notification handler code here
	
}

void CHostDlg::OnBSetDA0() //set DA 0 value = input
{
	 char buff[20];
	 int i;
	 sprintf_s(cTx,"S%cD0xxxx",tmpc);
	 DA_Value[0].GetLine(1,buff,8);
	 for(i = 0;i<6;i++){
		  if(buff[i] == ' ')
				buff[i] = '0';
	 }
	 if(buff[0] == '0' && ((buff[1] == 'x')||(buff[1] == 'X')))
		  strncpy(&cTx[4],buff+2,4);
	 else
		  strncpy(&cTx[4],buff,4);
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);
}

void CHostDlg::OnBSetDA1() //set DA 1 value = input
{
	 char buff[20];
	 int i;
	 sprintf_s(cTx,"S%cD1xxxx",tmpc);
	 DA_Value[1].GetLine(1,buff,8);
	 for(i = 0;i<6;i++){
		  if(buff[i] == ' ')
				buff[i] = '0';
	 }
	 if(buff[0] == '0' && ((buff[1] == 'x')||(buff[1] == 'X')))
		  strncpy(&cTx[4],buff+2,4);
	 else
		  strncpy(&cTx[4],buff,4);
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);
}

void CHostDlg::OnRDAAuto()
{

}
void CHostDlg::OnRDAManual() 
{
}
void CHostDlg::OnRDIOAuto() 
{
	// TODO: Add your control notification handler code here
	
}

void CHostDlg::OnRDIOManual() 
{
	// TODO: Add your control notification handler code here
	
}

void CHostDlg::OnReleasedcaptureSliDa0(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	char tmpstr[20];
	*pResult = 0;
	sprintf_s(tmpstr,"0x%4X",SliDA[0].GetPos());
	DA_Value[0].SetWindowText(tmpstr);

}

void CHostDlg::OnReleasedcaptureSliDa1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	char tmpstr[20];
	*pResult = 0;
	sprintf_s(tmpstr,"0x%4X",SliDA[1].GetPos());
	DA_Value[1].SetWindowText(tmpstr);
}
void CHostDlg::SetDA0Range(UINT idButton){
	 idButton -= IDC_R_DA0_Range0;
	 //if current output selected, cmd need to be plus 1
	 if(idButton > 3)
		  idButton += 1;
	 sprintf_s(cTx,"S%cDG0%d",tmpc,idButton);
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);
}
void CHostDlg::SetDA1Range(UINT idButton){
	 idButton -= IDC_R_DA1_Range0;
	 //if current output selected, cmd need to be plus 1
	 if(idButton > 3)
		  idButton += 1;
	 sprintf_s(cTx,"S%cDG1%d",tmpc,idButton);
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);
}
void CHostDlg::SetADRange(UINT idButton){
	 idButton -= IDC_R_AD_Range0;
	 //if not auto
	 if(idButton != 0)
		  idButton -= 1;
	 sprintf_s(cTx,"S%cAG%d",tmpc,idButton);
	 fSuccess = WriteFile(hCom,cTx,8,&num,NULL);
	 fSuccess = ReadFile(hCom,cRx,BUFFMAX,&num,NULL);
}
void CHostDlg::ADDraw(UINT idButton){
	idButton -= IDC_B_ADC_0;
	DrawChannel = idButton;
	dlg.Exist = true;
	dlg.DoModal();
}

void CHostDlg::OnCbnSelchangeCombo1()
{
}
