﻿//=========================================================
//Description : USB Seriel product demo program for C#
//DLL Version : USBDII.dll V 2.0.1.9
//Release Date : 2016/12/08
//Author : Samuel Tseng
//
//Copyright 2016 Decision Computer
//All Right Reserved
//=========================================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;    // use "Platform Invoke" to import USBDII.DLL

//USBDII.dll External function import
//MANUAL
//http://www.usb-industrial.com/download/document/manual/manual_usb_16_photo_input_relay_output_board.pdf


namespace Decision_USB_Dll_Demo
{
    public partial class Form1 : Form
    {

        // User should use type "IntPtr" to replace "handle" in C#.  
        // User should use  declear "unsafe" in "byte *" in C#  
        // and check the property in project->property->build "Allow unsafe code"

        [DllImport("USBDII.dll")]public static extern IntPtr hid_OpenDevice(uint card_type, uint card_id);
        [DllImport("USBDII.dll")]public static extern Boolean hid_CloseDevice(IntPtr hUSB);
        [DllImport("USBDII.dll")]public static extern unsafe Boolean hid_GetDigitalByte(IntPtr hUSB, uint address, byte* data);
        [DllImport("USBDII.dll")]public static extern Boolean hid_SetDigitalByte(IntPtr hUSB, uint address, byte data);
        
        [DllImport("USBDII.dll")]public static extern IntPtr com_OpenDevice(uint card_type, uint card_id, uint com_num);
        [DllImport("USBDII.dll")]public static extern Boolean com_CloseDevice(IntPtr hCOM);
        [DllImport("USBDII.dll")]public static extern unsafe Boolean com_GetDigitalByte(IntPtr hCOM, uint address, byte* data);
        [DllImport("USBDII.dll")]public static extern Boolean com_SetDigitalByte(IntPtr hCOM, uint address, byte data);

        public IntPtr hDevice;
        public byte P2RoutData, P3RoutData;
        private bool lResult;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            P2RoutData = 0;
            P3RoutData=0;
            
        }

        // open device 

        private void button1_Click(object sender, EventArgs e) 
        {

        uint DevId = (uint)DeviceNum.Value;
        uint COM_Num = (uint)COMNum.Value;
        uint DevType = 3;



        /*
        'USB_16PIO   0x01
        'USB_LABKIT  0x02
        'USB_16PR    0x03
        'USB_STARTER 0x04
        'USB_14ADDA  0x05
        'USB_8PR     0x06
        'USB_4PR     0x07
        'USB_8PI     0x08
        'USB_8RO     0x09
        'USB_16PI    0x0A
        'USB_16RO    0x0B
        'USB_32PI    0x0C
        'USB_32RO    0x0D
        'mini_USB_4PR    0x10
         */

        if (button1.Text == "Open Device"){

            // DevType 03 as USB_16PR ; card_number 0 as first device (blue switch setting on the board)
            if (Option1.Checked == true)   //Open
                hDevice = hid_OpenDevice(DevType, DevId);  //	select device by user
            else
                hDevice = com_OpenDevice(DevType, DevId, COM_Num); //	select device by user
   
            if ((int)hDevice == -1){ //open error
				richTextBox1.Text += "Fail to get device base address\n";
            }else{
				richTextBox1.Text += "Handel Value = " + Convert.ToString(hDevice)+"\nOpen Success\n";
                button1.Text = "Close Device";
            }
        }else{
            if ((int)hDevice == 0) return;

            if (Option1.Checked == true)     // close device
                hid_CloseDevice(hDevice); 	
            else
                com_CloseDevice(hDevice);
            
            hDevice = (IntPtr)0;
            richTextBox1.Text += "Device Close\n";
            button1.Text = "Open Device";
        }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            byte temp;
 
            unsafe
            {
                temp = 0;
                if ((int)hDevice == 0 ) return;

                if (Option1.Checked == true) //  Get TB3
                    lResult = hid_GetDigitalByte(hDevice, 0, &temp);
                else
                    lResult = com_GetDigitalByte(hDevice, 0, &temp);

                if( lResult == true)
                    richTextBox1.Text += "Port0 =" + (int)temp + "\n";
                else
                    richTextBox1.Text += "Port0 Read Error\n";

                for (int i = 0 ;i<8;i++){
                    if ((temp & (byte)Math.Pow(2, i)) == (byte)Math.Pow(2, i)) 
                        P0P(i, "1");
                    else
                        P0P(i, "0");
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            {
                byte temp;

                unsafe
                {
                    temp = 0;
                    if ((int)hDevice == 0) return;

                    if (Option1.Checked == true) //  Get TB3
                        lResult = hid_GetDigitalByte(hDevice, 1, &temp);
                    else
                        lResult = com_GetDigitalByte(hDevice, 1, &temp);

                        if (lResult == true)
                            richTextBox1.Text += "Port1 =" + (int)temp + "\n";
                        else
                            richTextBox1.Text += "Port1 Read Error\n";

                    for (int i = 0; i < 8; i++)
                    {
                        if ((temp & (byte)Math.Pow(2, i)) == (byte)Math.Pow(2, i))
                            P1P(i, "1");
                        else
                            P1P(i, "0");
                    }
                }
            }
        }
        
        public void P0P(int port, String txt) {
            switch (port)
            {
                case 0:
                    P0P0.Text = txt;
                    break;
                case 1:
                    P0P1.Text = txt;
                    break;
                case 2:
                    P0P2.Text = txt;
                    break;
                case 3:
                    P0P3.Text = txt;
                    break;
                case 4:
                    P0P4.Text = txt;
                    break;
                case 5:
                    P0P5.Text = txt;
                    break;
                case 6:
                    P0P6.Text = txt;
                    break;
                case 7:
                    P0P7.Text = txt;
                    break;
                default:
                    Console.WriteLine("Default case");
               //     Text1.Text = "P0D input port Error";
                    break;
            }        
        }

        public void P1P(int port ,String txt){

        switch(port){
        case 0:
            P1P0.Text = txt;
            break;
        case 1:
            P1P1.Text = txt;
            break;
        case 2:
            P1P2.Text = txt;
            break;
        case 3:
            P1P3.Text = txt;
            break;
        case 4:
            P1P4.Text = txt;
            break;
        case 5:
            P1P5.Text = txt;
            break;
        case 6:
            P1P6.Text = txt;
            break;
        case 7:
            P1P7.Text = txt;
            break;
        default:
            Console.WriteLine("Default case");
       //     Text1.Text = "P0D input port Error";
            break;
        }

        }


                public void P2R(int port ){
                     if ((P2RoutData & (byte)Math.Pow(2, port)) == (byte)Math.Pow(2, port)){
                        P2RoutData -=  (byte)Math.Pow(2, port);
                    }else{
                        P2RoutData += (byte)Math.Pow(2, port);
                    }

                    if (Option1.Checked == true){    //Set
                        lResult = hid_SetDigitalByte(hDevice, 2, P2RoutData);
                    }else{      
                        lResult = com_SetDigitalByte(hDevice, 2, P2RoutData);
                    }

                    if( lResult ==true){
                        richTextBox1.Text += "Write " + P2RoutData + " to Port #2 !\n";

                    //Case 0
                    if((P2RoutData &1)==1)
                        P2R0.Text = "1";
                    else
                        P2R0.Text = "0";

                    //Case 1
                    if((P2RoutData & 2)==2) 
                        P2R1.Text = "1";
                    else
                        P2R1.Text = "0";

                    //Case 2
                    if((P2RoutData &4)==4) 
                        P2R2.Text = "1";
                    else
                        P2R2.Text = "0";

                    //Case 3
                    if((P2RoutData & 8)==8) 
                        P2R3.Text = "1";
                    else
                        P2R3.Text = "0";

                    //Case 4
                    if((P2RoutData & 16)==16) 
                        P2R4.Text = "1";
                    else
                        P2R4.Text = "0";

                    //Case 5
                    if((P2RoutData & 32)==16) 
                        P2R5.Text = "1";
                    else
                        P2R5.Text = "0";

                    //Case 6
                    if((P2RoutData & 64)==64) 
                        P2R6.Text = "1";
                    else
                        P2R6.Text = "0";

                    //Case 7
                    if((P2RoutData & 128)==128) 
                        P2R7.Text = "1";
                    else
                        P2R7.Text = "0";
                    }
                }

                public void P3R(int port)
                {
                    if ((P3RoutData & (byte)Math.Pow(2, port)) == (byte)Math.Pow(2, port))
                    {
                        P3RoutData -= (byte)Math.Pow(2, port);
                    }
                    else
                    {
                        P3RoutData += (byte)Math.Pow(2, port);
                    }

                    if (Option1.Checked == true)
                    {    //Set
                        lResult = hid_SetDigitalByte(hDevice, 3, P3RoutData);
                    }
                    else
                    {
                        lResult = com_SetDigitalByte(hDevice, 3, P3RoutData);
                    }

                    
                    if (lResult == true)
                    {
                        richTextBox1.Text += "Write " + P3RoutData + " to Port #3  Success !";
                        //Case 0
                        if ((P3RoutData &  1)==1)
                            P3R0.Text = "1";
                        else
                            P3R0.Text = "0";

                        //Case 1
                        if ((P3RoutData &  2)==2)
                            P3R1.Text = "1";
                        else
                            P3R1.Text = "0";

                        //Case 2
                        if ((P3RoutData & 4)==4)
                            P3R2.Text = "1";
                        else
                            P3R2.Text = "0";

                        //Case 3
                        if ((P3RoutData & 8)==8)
                            P3R3.Text = "1";
                        else
                            P3R3.Text = "0";

                        //Case 4
                        if ((P3RoutData & 16)==16)
                            P3R4.Text = "1";
                        else
                            P3R4.Text = "0";

                        //Case 5
                        if ((P3RoutData & 32)==32)
                            P3R5.Text = "1";
                        else
                            P3R5.Text = "0";

                        //Case 6
                        if ((P3RoutData & 64)==64)
                            P3R6.Text = "1";
                        else
                            P3R6.Text = "0";

                        //Case 7
                        if ((P3RoutData & 128)==128)
                            P3R7.Text = "1";
                        else
                            P3R7.Text = "0";
                    }
                }

                private void P2R0_Click(object sender, EventArgs e)
                {
                    P2R(0);
                }

                private void P2R1_Click(object sender, EventArgs e)
                {
                    P2R(1);
                }

                private void P2R2_Click(object sender, EventArgs e)
                {
                    P2R(2);
                }

                private void P2R3_Click(object sender, EventArgs e)
                {
                    P2R(3);
                }

                private void P2R4_Click(object sender, EventArgs e)
                {
                    P2R(4);
                }

                private void P2R5_Click(object sender, EventArgs e)
                {
                    P2R(5);
                }

                private void P2R6_Click(object sender, EventArgs e)
                {
                    P2R(6);
                }

                private void P2R7_Click(object sender, EventArgs e)
                {
                    P2R(7);
                }

                private void P3R0_Click(object sender, EventArgs e)
                {
                    P3R(0);
                }

                private void P3R1_Click(object sender, EventArgs e)
                {
                    P3R(1);
                }

                private void P3R2_Click(object sender, EventArgs e)
                {
                    P3R(2);
                }

                private void P3R3_Click(object sender, EventArgs e)
                {
                    P3R(3);
                }

                private void P3R4_Click(object sender, EventArgs e)
                {
                    P3R(4);
                }

                private void P3R5_Click(object sender, EventArgs e)
                {
                    P3R(5);
                }

                private void P3R6_Click(object sender, EventArgs e)
                {
                    P3R(6);
                }

                private void P3R7_Click(object sender, EventArgs e)
                {
                    P3R(7);
                }

                private void Option1_CheckedChanged(object sender, EventArgs e)
                {
                    COMNum.Visible = false;
                    comlabel.Visible = false;
                }

                private void Option2_CheckedChanged(object sender, EventArgs e)
                {
                    COMNum.Visible = true;
                    comlabel.Visible = true;
                }

    }
}